﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=5.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private serial As Serial
	Private admin As BluetoothAdmin
	Private ast As AsyncStreamsText
	Private mPhoneWakeState As PhoneWakeState
	Private bc As ByteConverter
	Public connected As Boolean
	Public connecting As Boolean
	'Private bb As ByteConverter
	Public GPS1 As GPS
	Public gpsStarted As Boolean
End Sub

Public Sub ulScreen(u As Boolean)    
	''se u=true non permette allo schermo di andare in lock 
	If u Then
		mPhoneWakeState.KeepAlive(True)
	Else
		mPhoneWakeState.ReleaseKeepAlive		
	End If	
End Sub

Sub Service_Create
	serial.Initialize("serial")
	admin.Initialize("admin")
	GPS1.Initialize("GPS")
End Sub

Public Sub StartGps
	If gpsStarted = False Then
		GPS1.Start(0, 0)
		gpsStarted = True
		Log("GPS avviato")
	End If
End Sub

Public Sub StopGps
	If gpsStarted Then
		GPS1.Stop
		gpsStarted = False
		Log("GPS arrestato")
	End If
End Sub

Sub GPS_LocationChanged (Location1 As Location)
	CallSub2(Main, "LocationChanged", Location1)
End Sub

Public Sub Connect
	admin.StartDiscovery
	connecting = True
	CallSub(Main, "SetState")
End Sub

Private Sub admin_DeviceFound (Name As String, MacAddress As String)
	Log($"Device found: ${Name}"$)
	If Name = "HC-05_1" Then
		Log("Trying to connect...")
		admin.CancelDiscovery
		serial.Connect(MacAddress)
	End If
End Sub

Private Sub admin_DiscoveryFinished
	connecting = False
End Sub

Private Sub Serial_Connected (Success As Boolean)
	If Success Then
		If ast.IsInitialized Then ast.Close
		ast.Initialize(Me, "Ast", serial.InputStream, serial.OutputStream)
		Log("Connected")
		connected = True
		
	Else
		Log(LastException)
	End If
	connecting = False
	CallSub(Main, "SetState")
End Sub

Public Sub SendMessage(msg() As Byte)
	ast.astreams.Write(msg) 'sending bytes, not text
	Log($"Inviato: "${bc.StringFromBytes(msg,"US-ASCII")}""$)
End Sub

Private Sub ast_NewText (Text As String)
	'ricevo messaggio completo
	CallSub2(Main, "MessageFromDevice", Text)
End Sub

Private Sub ast_Terminated
	connected = False
	CallSub(Main, "SetState")
End Sub



Sub Service_Start (StartingIntent As Intent)

End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	StopGps
End Sub

Sub convertStr2Byte(s As String) As Byte()
	Dim r() As Byte
	r = bc.StringToBytes(s,"US-ASCII")
	Return r
End Sub

Sub convertInt2Byte(i As Int) As Byte()
	Private r() As Byte
	Private x() As Int = Array As Int(i)
	r = bc.IntsToBytes(x)
	Return r
End Sub

